#include "myheader.h"

int m, n;
int log2p;

void broadcast(int k, double pivot[]){
  for (int i=0; i<log2p; i++){
    if ((MyProcId & (1 << i)) != ((k / m) & (1 << i)))
      receive<double>(MyProcId ^ (1<<i), pivot, n+1);
    else send<double>(MyProcId ^ (1<<i), pivot, n+1);}}
  
int main (int argc, char * argv[]) 
{ init(argc,argv);
  n = Problemsize;
  log2p = (int) (log(p)/log(2)+0.1); 
  m = n/p; 
  int nbuf = n;  int l, j, k;

  MPI_Bcast(&nbuf,1,MPI_INT,0,MPI_COMM_WORLD);
  double** A = new double*[m];
  for(l=0; l<m; l++) A[l] = new double[n+1];
  double* pivot = new double[n+1];
  double Alk;
  int base = MyProcId*m; 

  /* init A */
  for (l=0; l<m; l++)  
    for (j=0; j<=n; j++) A[l][j] = (base+l == j) ? 1.0 : 2.0;
  showMatrix(A,p,1,m,n+1);

  /* Gaussian elimination */
  for (k=0; k<n; k++){
    for (j=0; j<=n; j++) pivot[j] = A[k%m][j] / A[k%m][k];
    broadcast(k,pivot);
    for (l=0; l<m; l++){
      Alk = A[l][k];
      for (j=0; j<=n; j++)
        A[l][j] -= (base+l == k) ? 0.0 : Alk * pivot[j];}}
  for (l=0; l<m; l++) {A[l][n] /= A[l][base+l]; A[l][base+l] = 1.0;}
  showMatrix(A,p,1,m,n+1); 
  for(l=0; l<m; l++) delete[] A[l];
  delete[] A; delete[] pivot;
  finish();
}
    
