#include "Skeleton.h"
#include <stdlib.h>

// general assumption: higher bits to the left of lower bits
int log2size;   

int random(int i){int r= rand(); srand(r+sk_myid); return rand() % 100;}

bool odd(int i){return i&1 != 0;}

int bitsum(int i){int sum = 0; while (i>0){sum += (i & 1); i >>= 1;} return sum;}

bool initDirection(int i){return odd(bitsum(i>>1));}

bool adjustDirection(const DistributedArray<bool>& Dir, int i, bool d){
  return odd(i) ?  Dir.get(i-1)  :  d;}

template <class C>
C min(C x, C y){return (x>y) ? x : y;}

template <class C>
C max(C x, C y){return (x<=y) ? x : y;}

template <class C>
C sorter(const DistributedArray<C>& A, const DistributedArray<bool>& Dir, int i, C x){
  typedef DistributedArray<C>& MutableA;
  if (odd(i)) return x; // elements at odd positions are processed by their neighbors
  else {
   C neighbor = A.get(i+1);
   if (Dir.get(i)){ const_cast<MutableA>(A).set(i+1,max(neighbor,x)); // slightly dirty 
                    return min(neighbor,x);}
   else { const_cast<MutableA>(A).set(i+1,min(neighbor,x));           // slightly dirty
          return max(neighbor,x);}}}

int clsh(int k, int i){int mask = 1 << k;
  return (i & mask) ? ((i ^ mask) << 1) + 1  :   i << 1;}

template <class C>
DistributedArray<C> bitonic( DistributedArray<C> A){
    int l,j;
    DistributedArray<bool> SortDirection(Problemsize,& initDirection);		
    typedef C (*sorter_t)(const DistributedArray<C>&,
                          const DistributedArray<bool>&,
  		                    int,C);    
    A.mapIndexInPlace(curry((sorter_t)sorter<C>)(A)(SortDirection));
    for (l=1; l<log2size; l++){
      for (j=0; j<log2size-l-1; j++){ 
        A.permute(curry(clsh)(log2size-1));
        SortDirection.permute(curry(clsh)(log2size-1));}
      for (j=log2size-l-1; j<log2size; j++){
        A.permute(curry(clsh)(log2size-1)); 
        SortDirection.permute(curry(clsh)(log2size-1));
        A.mapIndexInPlace(curry((sorter_t)sorter<C>)(A)(SortDirection)); 
        SortDirection.mapIndexInPlace(curry(adjustDirection)(SortDirection));}}
    return A;}

int main(int argc, char **argv){
//********************************************************************************
// Test: bitonic sort (algorithm similar to Quinn: Parallel Computing, p. 268)
//********************************************************************************
  try{
    InitSkeletons(argc,argv);
    log2size = log2(Problemsize);

    DistributedArray<int> A(Problemsize,& random); A.show();
    DistributedArray<int> B = bitonic(A);

#if Output == 1
    B.show();
#endif

    TerminateSkeletons();}
  catch(Exception&){cout << "Exception" << endl << flush;};                 
}
