// Utility class to browse parameters to progeram
// (c) J. Striegnitz
#include <stdarg.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>
#include "optbrowser.h"

COptBrowser::COptBrowser(char c,char **v) {
  argc = c;
  argv = v;
}

bool COptBrowser::getOpt(const char* opt,const char* format,...)
{
  int i;
  for (i=0 ; i<argc ; i++) {
    if (! strcmp(opt,argv[i])) 
      break;
  }      
  if (i==argc)
    return false;
  va_list ap;
  if (! format)
    return true;
  i++;
  va_start(ap,format);
  while (*format)
    {
      if (i>=argc)
	return false;
      switch (*format++)
	{
	case 's':
	  strcpy(va_arg(ap,char*),argv[i]);
	  i++;
	  break;
	case 'd':
	  errno=0;
	  *va_arg(ap,int*)=strtol(argv[i],0,10);
	  if (errno) {
	    return false;
	  }    
	  i++;
	  break;
	case 'g':
	  errno=0;
	  *va_arg(ap,double*)=strtod(argv[i],0);
	  if (errno)
	    return false;
	  i++;
	  break;
	};
    };
  va_end(ap);

  return true;
}


bool COptBrowser::getNextOpt(int & nr,const char* opt,const char* format,...)
{
  int i;
  int v=0;
  for (i=0 ; i<argc ; i++) {
    if ( ! strcmp(opt,argv[i]) ) {
      if (v == nr )
        break;      
      v++;
    }  	     	
  }      
  if (i==argc)
    return false;
    
  va_list ap;
  if (! format)
    return true;
  i++;
  nr++;
  va_start(ap,format);
  while (*format)
    {
      if (i>=argc)
	return false;
      switch (*format++)
	{
	case 's':
	  strcpy(va_arg(ap,char*),argv[i]);
	  i++;
	  break;
	case 'd':
	  errno=0;
	  *va_arg(ap,int*)=strtol(argv[i],0,10);
	  if (errno) {
	    return false;
	  }    
	  i++;
	  break;
	case 'g':
	  errno=0;
	  *va_arg(ap,double*)=strtod(argv[i],0);
	  if (errno)
	    return false;
	  i++;
	  break;
	};
    };
  va_end(ap);

  return true;
}
