#include "Skeleton.h"

const int processors = 4;
const int size = 40;

int id(int a) {return a;}

int* initHomIndex(int i){   // equally sized blocks (gap on each processor)
  int* idx= new int[processors+1];
  for (int j=0; j<=processors; j++) idx[j] = j*(size/(processors*processors));
  return idx;}

int* initInhomIndex(int i){ // varying block sizes, no gaps
  int* idx= new int[processors+1];
  idx[0] = 0;
  for (int j=1; j<=processors; j++) idx[j] = idx[j-1] + (j+i-1)%processors+1;
  return idx;}

int main(int argc, char **argv){
//*************************************************************
// Test: allToAll
// *************************************************************
  try{
    InitSkeletons(argc,argv);

    DistributedArray<int> A(size,& id);
    A.show();
    DistributedArray<int *> Index(processors,& initHomIndex); 
    A.allToAll(Index,9999); 
    A.show();

    DistributedArray<int> B(size,& id);
    DistributedArray<int *> Index2(processors,& initInhomIndex);
    B.allToAll(Index2,9999); 
    B.show();

    TerminateSkeletons();}
  catch(Exception&){cout << "Exception" << endl << flush;};                  
}
