#include "Skeleton.h"

static int current = 0;

int* init(Empty dummy){if (current++ < 1) return &current;
                       else return NULL;}

bool gth(int x,int y){return x>y;}
bool lth(int x,int y){return x<y;}

void solve(Empty dummy){
  int* valref;
  do{
    valref = get<int>(); // NULL indicates termination
    if (valref != NULL) {
      put<int>((*valref)*2); put<int>((*valref)*2+1);}
  }while (valref != NULL);}

int square(int x){return x * x;}
 
void fin(int n){cout << "Result: "<< n << endl << flush;}

int main(int argc, char **argv){

// *************************************************************
// Test: test of branch and bound skeleton
// ************************************************************* 

  try{
    InitSkeletons(argc,argv);
// step 1: create a process topology (using C++ constructors)
    Initial<int>        p1(init); 
    Filter<int,int>     p2(solve,1);
    BranchAndBound<int> p3(p2,2,gth,curry(lth)(100)); 
    Final<int>          p4(& fin);  
    Pipe                p5(p1,p3,p4);

// step 2: 
// (each processor will pick its part of the computation
// depending on its rank)
    
    p5.start();

    TerminateSkeletons();}
  catch(Exception&){cout << "Exception" << endl << flush;}
}
