#include "Skeleton.h"

int add(const int a, const int b){return a+b;}

int sum(const int a, const int b, const int c){return a+b+c;}

int times(const int a, const int b){return a*b;}

int id(int a) {return a;}

int exor(int a, int b){return ((unsigned int)a)^((unsigned int)b);}

int main(int argc, char **argv){
//*************************************************************
// Test 2: test of data parallel skeletons
// *************************************************************
  try{
    InitSkeletons(argc,argv);

    int a[20];
    for (int i=0; i<20; i++) a[i] = i;
    DistributedArray<int> E(20,a);
    E.permute(curry(exor)(2));
    DistributedArray<int> A(20,curry(id));  
    A.mapIndexInPlace(curry(add));
    DistributedArray<int> B = A.mapIndex(& add);
    A.zipWithIndexInPlace(B,& sum);
    A.zipWithInPlace(E,& times);
    B.permutePartition(curry(exor)(1));
    B.broadcastPartition(2);
    B.broadcast(17);   
    B.scan(curry(add));
    B.mapInPlace(curry(add)(1));
    int result =  A.fold(curry(add)); 
    DistributedArray<int> C = A.zipWith(B,& times);
    DistributedArray<int> D = C.map(curry(add)(result)); 
    D.show(); // uses gather internally

    TerminateSkeletons();}
  catch(Exception&){cout << "Exception" << endl << flush;};                  
}
