#include "Skeleton.h"

static int current = 0;

int* init(Empty dummy){if (current++ < 20) return &current;
            else return NULL;}

int square(int x){return x * x;}

void fin(int n){cout << "square: "<< n << endl << flush;}

template <class I, class O> 
inline Process* NestedFarm(Process& worker, int length){
  int sqrtl = (int) (sqrt(length)+0.1);
  Farm<I,O>*  p1 = new Farm<I,O>(worker,sqrtl);
  Farm<I,O>*  p2 = new Farm<I,O>(*p1,sqrtl);
  return p2;}

int main(int argc, char **argv){

// *************************************************************
// Test: nested farm
// ************************************************************* 

  try{
    InitSkeletons(argc,argv);
// step 1: create a process topology (using C++ constructors)

    Initial<int>     p1(init); 
    Atomic<int,int>  p2(square,1);
    Process*         p3 = NestedFarm<int,int>(p2,4); 
    Final<int>       p4(fin);  
    Pipe             p5(p1,*p3,p4);

    if (Debug) p5.show();

// step 2: 
// (each processor will pick its part of the computation
// depending on its rank)
    
    p5.start();

    TerminateSkeletons();}
  catch(Exception&){cout << "Exception" << endl << flush;}
}
