// this shows, how a new skeleton can be created based on
// exiting ones: (a direct implementation is, of course,
// also possible (and more efficient))
//
// **********************  Par skeleton ********************
// the Par Skeleton takes a sequence of input values;
// each input value is passed to a number of subprocesses,
// which process this value in parallel. The results of
// the subprocesses are merged into a single sequence of
// output values.

template<class I>
void duplicate(int length){
  int* valref;
  while ((valref = get<I>()) != NULL)
    for(int i=0; i<length; i++)
      put<I>(*valref);}

template <class I, class O> 
Process par(Process** ps, int length){
  Filter<I,I> p1(curry(duplicate)(length),1);
  Farm<I,O>   p2(ps,length);
  return new Pipe(p1,p2);}