#include "Skeleton.h"
#include <stdlib.h>

int random(int i){int r= rand(); srand(r+sk_myid); return rand() % 1000000;}

template <class C>
int* initIndex(const DistributedArray<C>& A, int selection[], int i){ 
  int* idx= new int[sk_numprocs+1];
  idx[0] = 0; 
  int j = 0;  int k = 0;
  while ((k<=A.getLocalSize()) && (j<sk_numprocs-1))
    if (A.getLocal(k) >= selection[j]) idx[++j] = k;
    else k++; 
  for (k= j+1; k<= sk_numprocs; k++) idx[k] = A.getLocalSize();
  return idx;}  

template <class C>
C takeSample(const DistributedArray<C>& A, int i){
  return A.get(i*Problemsize/(sk_numprocs*sk_numprocs));}

template <class C>
C moveResult(C *sorted, int i, C x){return sorted[i];}

template <class C>
void quicksort(int low, int high, C* _a) {

    typedef C* MutableA;
		MutableA a = const_cast<MutableA>(_a);
		
    if (low >= high) return;
    int left = low;  int right = high;
    int pivot = a[(low+high)/2];
    do { while (a[left] < pivot) left++;
         while(a[right] > pivot) right--;
         if (left <= right){
           int temp = a[right];
           a[right--] = a[left];
           a[left++] = temp;}}
    while (left <= right);
    if (low < right) quicksort(low,right,a);
    if (high > left) quicksort(left,high,a);}

template <class C>
void samplesort(DistributedArray<C>& A, C maxVal){
  typedef void (*quicksort_t)(int,int,C*);  
  typedef C (*takeSample_t)(const DistributedArray<C>&, int i);
  typedef int* (*initIndex_t)(const DistributedArray<C>&, int*, int ); 
  typedef C (*moveResult_t)(C*, int i, C);
  int i;
  A.mapPartitionInPlace(curry((quicksort_t)quicksort<C>)(0)(A.getLocalSize()-1) );
  DistributedArray<C> Sample(sk_numprocs*sk_numprocs,curry((takeSample_t)takeSample<C>)(A)); 
  C* sample = new C[sk_numprocs*sk_numprocs];
  Sample.gather(sample);
  quicksort(0,sk_numprocs*sk_numprocs-1,sample);
  C* selection = new C[sk_numprocs-1];
  for (i=0; i<sk_numprocs-1; i++)
    selection[i] = sample[(i+1)*sk_numprocs + sk_numprocs/2-1]; 
  DistributedArray<int *> Index(sk_numprocs,curry((initIndex_t)initIndex<C>)(A)(selection)); 
  int upperBound = 2*Problemsize/sk_numprocs; // could be refined
  DistributedArray<C> B = A.copyWithGap(sk_numprocs*upperBound, maxVal);
  B.allToAll(Index,maxVal);           // gaps are filled with maxVal  
  B.mapPartitionInPlace(curry((quicksort_t)quicksort<C>)(0)(upperBound-1)); 
  C* sorted = new C[sk_numprocs*upperBound];
  B.gather(sorted);
  int j = 0;
  for (i=0; i<sk_numprocs*upperBound; i++) // compaction (removes gaps)
    if (sorted[i] != maxVal) sorted[j++] = sorted[i]; 
  A.mapIndexInPlace(curry((moveResult_t)moveResult<C>)(sorted));
  delete[] sample; delete[] selection; delete[] sorted;}


int main(int argc, char **argv){
//*****************************************************************************
// Test: samplesort (algorithm from M. Quinn: Parallel Computing, 1994, p. 281)
// ****************************************************************************
  try{
    InitSkeletons(argc,argv);

    DistributedArray<int> A(Problemsize,& random); 
#if Output == 1
      A.show();
#endif

      samplesort(A,9999);

#if Output == 1
      A.show();
#endif

    TerminateSkeletons();}
  catch(Exception&){cout << "Exception" << endl << flush;}                
}
